(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms')) :
    typeof define === 'function' && define.amd ? define('orgenic-ui-angular-forms', ['exports', '@angular/core', '@angular/forms'], factory) :
    (global = global || self, factory(global['orgenic-ui-angular-forms'] = {}, global.ng.core, global.ng.forms));
}(this, (function (exports, core, forms) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/og-text-input.directive.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var OgTextInputDirective = /** @class */ (function () {
        function OgTextInputDirective(elementRef) {
            this.elementRef = elementRef;
            this.onChange = (/**
             * @return {?}
             */
            function () { });
            this.onTouched = (/**
             * @return {?}
             */
            function () { });
        }
        Object.defineProperty(OgTextInputDirective.prototype, "value", {
            get: /**
             * @return {?}
             */
            function () {
                return this.internalValue;
            },
            set: /**
             * @param {?} val
             * @return {?}
             */
            function (val) {
                if (val !== this.internalValue) {
                    this.internalValue = val;
                    this.onChange(this.internalValue);
                    this.onTouched();
                    this.elementRef.nativeElement.value = val;
                    /** @type {?} */
                    var event_1 = new CustomEvent('valueChanged', { detail: val });
                    this.elementRef.nativeElement.dispatchEvent(event_1);
                }
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} value
         * @return {?}
         */
        OgTextInputDirective.prototype.listenForValueChange = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            this.value = value;
        };
        /**
         * @param {?} value
         * @return {?}
         */
        OgTextInputDirective.prototype.writeValue = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            if (!value) {
                value = '';
            }
            this.value = value;
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        OgTextInputDirective.prototype.registerOnChange = /**
         * @param {?} fn
         * @return {?}
         */
        function (fn) {
            this.onChange = fn;
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        OgTextInputDirective.prototype.registerOnTouched = /**
         * @param {?} fn
         * @return {?}
         */
        function (fn) {
            this.onTouched = fn;
        };
        /**
         * @param {?} disabled
         * @return {?}
         */
        OgTextInputDirective.prototype.setDisabledState = /**
         * @param {?} disabled
         * @return {?}
         */
        function (disabled) {
            this.elementRef.nativeElement.disabled = disabled;
        };
        OgTextInputDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: 'og-text-input',
                        providers: [
                            {
                                provide: forms.NG_VALUE_ACCESSOR,
                                useExisting: core.forwardRef((/**
                                 * @return {?}
                                 */
                                function () { return OgTextInputDirective; })),
                                multi: true
                            }
                        ]
                    },] }
        ];
        /** @nocollapse */
        OgTextInputDirective.ctorParameters = function () { return [
            { type: core.ElementRef }
        ]; };
        OgTextInputDirective.propDecorators = {
            listenForValueChange: [{ type: core.HostListener, args: ['valueChanged', ['$event.detail'],] }]
        };
        return OgTextInputDirective;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        OgTextInputDirective.prototype.internalValue;
        /** @type {?} */
        OgTextInputDirective.prototype.onChange;
        /** @type {?} */
        OgTextInputDirective.prototype.onTouched;
        /**
         * @type {?}
         * @private
         */
        OgTextInputDirective.prototype.elementRef;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/og-checkbox.directive.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var OgCheckboxDirective = /** @class */ (function () {
        function OgCheckboxDirective(elementRef) {
            this.elementRef = elementRef;
            this.onChange = (/**
             * @return {?}
             */
            function () { });
            this.onTouched = (/**
             * @return {?}
             */
            function () { });
        }
        Object.defineProperty(OgCheckboxDirective.prototype, "value", {
            get: /**
             * @return {?}
             */
            function () {
                return this.internalValue;
            },
            set: /**
             * @param {?} val
             * @return {?}
             */
            function (val) {
                if (val !== this.internalValue) {
                    this.internalValue = val;
                    this.onChange(this.internalValue);
                    this.onTouched();
                    this.elementRef.nativeElement.checked = val;
                }
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} value
         * @return {?}
         */
        OgCheckboxDirective.prototype.listenForValueChange = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            this.value = value;
        };
        /**
         * @param {?} value
         * @return {?}
         */
        OgCheckboxDirective.prototype.writeValue = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            if (value) {
                this.value = value;
            }
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        OgCheckboxDirective.prototype.registerOnChange = /**
         * @param {?} fn
         * @return {?}
         */
        function (fn) {
            this.onChange = fn;
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        OgCheckboxDirective.prototype.registerOnTouched = /**
         * @param {?} fn
         * @return {?}
         */
        function (fn) {
            this.onTouched = fn;
        };
        /**
         * @param {?} disabled
         * @return {?}
         */
        OgCheckboxDirective.prototype.setDisabledState = /**
         * @param {?} disabled
         * @return {?}
         */
        function (disabled) {
            this.elementRef.nativeElement.disabled = disabled;
        };
        OgCheckboxDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: 'og-checkbox',
                        providers: [
                            {
                                provide: forms.NG_VALUE_ACCESSOR,
                                useExisting: core.forwardRef((/**
                                 * @return {?}
                                 */
                                function () { return OgCheckboxDirective; })),
                                multi: true,
                            }
                        ]
                    },] }
        ];
        /** @nocollapse */
        OgCheckboxDirective.ctorParameters = function () { return [
            { type: core.ElementRef }
        ]; };
        OgCheckboxDirective.propDecorators = {
            listenForValueChange: [{ type: core.HostListener, args: ['changed', ['$event.detail'],] }]
        };
        return OgCheckboxDirective;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        OgCheckboxDirective.prototype.internalValue;
        /** @type {?} */
        OgCheckboxDirective.prototype.onChange;
        /** @type {?} */
        OgCheckboxDirective.prototype.onTouched;
        /**
         * @type {?}
         * @private
         */
        OgCheckboxDirective.prototype.elementRef;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/orgenic-ui-angular-forms.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var FORMS_DIRECTIVES = [
        OgCheckboxDirective,
        OgTextInputDirective,
    ];
    var OrgenicUiAngularFormsModule = /** @class */ (function () {
        function OrgenicUiAngularFormsModule() {
        }
        OrgenicUiAngularFormsModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: FORMS_DIRECTIVES,
                        imports: [],
                        exports: FORMS_DIRECTIVES
                    },] }
        ];
        return OrgenicUiAngularFormsModule;
    }());

    exports.OrgenicUiAngularFormsModule = OrgenicUiAngularFormsModule;
    exports.ɵa = OgCheckboxDirective;
    exports.ɵb = OgTextInputDirective;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=orgenic-ui-angular-forms.umd.js.map
