import { Directive, forwardRef, ElementRef, HostListener, NgModule } from '@angular/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/og-text-input.directive.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class OgTextInputDirective {
    /**
     * @param {?} elementRef
     */
    constructor(elementRef) {
        this.elementRef = elementRef;
        this.onChange = (/**
         * @return {?}
         */
        () => { });
        this.onTouched = (/**
         * @return {?}
         */
        () => { });
    }
    /**
     * @return {?}
     */
    get value() {
        return this.internalValue;
    }
    /**
     * @param {?} val
     * @return {?}
     */
    set value(val) {
        if (val !== this.internalValue) {
            this.internalValue = val;
            this.onChange(this.internalValue);
            this.onTouched();
            this.elementRef.nativeElement.value = val;
            /** @type {?} */
            const event = new CustomEvent('valueChanged', { detail: val });
            this.elementRef.nativeElement.dispatchEvent(event);
        }
    }
    /**
     * @param {?} value
     * @return {?}
     */
    listenForValueChange(value) {
        this.value = value;
    }
    /**
     * @param {?} value
     * @return {?}
     */
    writeValue(value) {
        if (!value) {
            value = '';
        }
        this.value = value;
    }
    /**
     * @param {?} fn
     * @return {?}
     */
    registerOnChange(fn) {
        this.onChange = fn;
    }
    /**
     * @param {?} fn
     * @return {?}
     */
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    /**
     * @param {?} disabled
     * @return {?}
     */
    setDisabledState(disabled) {
        this.elementRef.nativeElement.disabled = disabled;
    }
}
OgTextInputDirective.decorators = [
    { type: Directive, args: [{
                selector: 'og-text-input',
                providers: [
                    {
                        provide: NG_VALUE_ACCESSOR,
                        useExisting: forwardRef((/**
                         * @return {?}
                         */
                        () => OgTextInputDirective)),
                        multi: true
                    }
                ]
            },] }
];
/** @nocollapse */
OgTextInputDirective.ctorParameters = () => [
    { type: ElementRef }
];
OgTextInputDirective.propDecorators = {
    listenForValueChange: [{ type: HostListener, args: ['valueChanged', ['$event.detail'],] }]
};
if (false) {
    /**
     * @type {?}
     * @private
     */
    OgTextInputDirective.prototype.internalValue;
    /** @type {?} */
    OgTextInputDirective.prototype.onChange;
    /** @type {?} */
    OgTextInputDirective.prototype.onTouched;
    /**
     * @type {?}
     * @private
     */
    OgTextInputDirective.prototype.elementRef;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/og-checkbox.directive.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class OgCheckboxDirective {
    /**
     * @param {?} elementRef
     */
    constructor(elementRef) {
        this.elementRef = elementRef;
        this.onChange = (/**
         * @return {?}
         */
        () => { });
        this.onTouched = (/**
         * @return {?}
         */
        () => { });
    }
    /**
     * @return {?}
     */
    get value() {
        return this.internalValue;
    }
    /**
     * @param {?} val
     * @return {?}
     */
    set value(val) {
        if (val !== this.internalValue) {
            this.internalValue = val;
            this.onChange(this.internalValue);
            this.onTouched();
            this.elementRef.nativeElement.checked = val;
        }
    }
    /**
     * @param {?} value
     * @return {?}
     */
    listenForValueChange(value) {
        this.value = value;
    }
    /**
     * @param {?} value
     * @return {?}
     */
    writeValue(value) {
        if (value) {
            this.value = value;
        }
    }
    /**
     * @param {?} fn
     * @return {?}
     */
    registerOnChange(fn) {
        this.onChange = fn;
    }
    /**
     * @param {?} fn
     * @return {?}
     */
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    /**
     * @param {?} disabled
     * @return {?}
     */
    setDisabledState(disabled) {
        this.elementRef.nativeElement.disabled = disabled;
    }
}
OgCheckboxDirective.decorators = [
    { type: Directive, args: [{
                selector: 'og-checkbox',
                providers: [
                    {
                        provide: NG_VALUE_ACCESSOR,
                        useExisting: forwardRef((/**
                         * @return {?}
                         */
                        () => OgCheckboxDirective)),
                        multi: true,
                    }
                ]
            },] }
];
/** @nocollapse */
OgCheckboxDirective.ctorParameters = () => [
    { type: ElementRef }
];
OgCheckboxDirective.propDecorators = {
    listenForValueChange: [{ type: HostListener, args: ['changed', ['$event.detail'],] }]
};
if (false) {
    /**
     * @type {?}
     * @private
     */
    OgCheckboxDirective.prototype.internalValue;
    /** @type {?} */
    OgCheckboxDirective.prototype.onChange;
    /** @type {?} */
    OgCheckboxDirective.prototype.onTouched;
    /**
     * @type {?}
     * @private
     */
    OgCheckboxDirective.prototype.elementRef;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/orgenic-ui-angular-forms.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const FORMS_DIRECTIVES = [
    OgCheckboxDirective,
    OgTextInputDirective,
];
class OrgenicUiAngularFormsModule {
}
OrgenicUiAngularFormsModule.decorators = [
    { type: NgModule, args: [{
                declarations: FORMS_DIRECTIVES,
                imports: [],
                exports: FORMS_DIRECTIVES
            },] }
];

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: orgenic-ui-angular-forms.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { OrgenicUiAngularFormsModule, OgCheckboxDirective as ɵa, OgTextInputDirective as ɵb };
//# sourceMappingURL=orgenic-ui-angular-forms.js.map
